<?php
/*
Plugin Name: Google plus stream Widget
Plugin URI: http://letusbuzz.com
Description: Google plus stream Widget
Author URI: http://letusbuzz.com
Author: Sudipto Pratap Mahato
Version: 1.0
*/
function gps_css()
{

?>
<style>
#gps-cont{
width:100%;
height:<?php echo get_option('gps_height','400px'); ?>;
overflow:scroll;
overflow-x: hidden;
border: 1px solid #EEEEEE;
background:#fff;
}
#gps-cont a,#gps-profile a{
text-decoration: none;
color:#3366CC;
}
#gps-cont img{
max-width:100%;
}
#gps-cont li{
border-bottom:1px solid #888;
list-style:none !important;
padding:5px !important;
background:none !important;
margin:0 !important;
}

#gps-cont ul {
    margin: 0 !important;
    padding: 0 !important;
}
#gps-dname{
font-size:14px;
font-weight:bold;
}
#gps-profile{
background:#F1F1F1;
padding:5px;
}
#gps-profimg {
    float: left;
    margin-top: 5px;
    padding-right: 5px;
}
#gps-credit a{
font-size:10px;
color:#888;
text-decoration:none;
}
#gps-credit img {
    float: left;
    margin-top: 4px;
}
</style>
<?php

}
add_action('wp_head','gps_css');

function gps_display_widget($args){
    extract($args); 
    $tt=get_option('gps_title','Google Plus Stream');
    echo $before_widget;
    if(trim($tt)!='')echo $before_title.$tt.$after_title;
        echo gps_display_stream();
    echo $after_widget; 
}
wp_register_sidebar_widget('gps_display_widget', 'Google Plus Stream', 'gps_display_widget');
function gps_cache($type)
{
	$tm=get_option('gps_ctime',0);
	$tm2=get_option('gps_ctime_prof',0);
	$min2cache=get_option('gps_m2c',15)*60;
	$tmdiff=-1;
	$cache=false;
	if($type!='stream')$tm=$tm2;
	if($tm==0)return false;
	else
	{
		$tmdiff=time()-$tm;
		if($tmdiff<$min2cache)
		{
			if($type==='stream')$cache=get_option('gps_cache',false);
			else $cache=get_option('gps_cache_prof',false);
		}
	}
	return $cache;
}
function gps_get_data_url($url)
{
      $aglist[] = "Mozilla/5.0 (compatible; Konqueror/4.0; Microsoft Windows) KHTML/4.0.80 (like Gecko)";
      $aglist[] = "Mozilla/5.0 (compatible; Konqueror/3.92; Microsoft Windows) KHTML/3.92.0 (like Gecko)";
      $aglist[] = "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0; WOW64; SLCC1; .NET CLR 2.0.50727; .NET CLR 3.0.04506; Media Center PC 5.0; .NET CLR 1.1.4322; Windows-Media-Player/10.00.00.3990; InfoPath.2";
      $aglist[] = "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; .NET CLR 1.1.4322; InfoPath.1; .NET CLR 2.0.50727; .NET CLR 3.0.04506.30; Dealio Deskball 3.0)";
      $aglist[] = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; NeosBrowser; .NET CLR 1.1.4322; .NET CLR 2.0.50727)";
      $ua = $aglist[array_rand($aglist)];
      if (function_exists('curl_init')) {
          $handle = curl_init();
          curl_setopt($handle, CURLOPT_URL, $url);
          curl_setopt($handle, CURLOPT_USERAGENT, $ua);
          curl_setopt($handle, CURLOPT_TIMEOUT, 60);
          curl_setopt($handle, CURLOPT_CONNECTTIMEOUT, 1);
          curl_setopt($handle, CURLOPT_RETURNTRANSFER, 1);
          curl_setopt($handle, CURLOPT_TIMEOUT, $timeout);
          curl_setopt($handle, CURLOPT_SSL_VERIFYPEER, false);
          $buffer = curl_exec($handle);
          curl_close($handle);
      } 
      else
      { 
      	$buffer =file_get_contents($url);
      }
       return $buffer;
 }
function gps_display_stream()
{
	$prof=gps_get_profile();
	$stre=gps_get_stream();
	if (get_option( 'gps_credit', true ) == true)$cre=gps_credit();else $cre='';
	return $prof.$stre.$cre;
		
}
function gps_credit()
{
	$c='<div id="gps-credit"><a href="http://letusbuzz.com/google-plus-stream-widget/" target="_blank"><img src="http://ssl.gstatic.com/s2/oz/images/favicon.ico"/> Google Plus Stream Widget</a></div>';
	return $c;
}
function gps_get_profile()
{
	$id = get_option('gps_profid','');
	$profileurl='https://www.googleapis.com/buzz/v1/people/'.$id.'/@self?alt=json';
	$plink='https://plus.google.com/'.$id.'/posts';
	 $cache=gps_cache('prof');
	 	if($cache!==false)return $cache;
	$dataprof=gps_get_data_url($profileurl);
	if($dataprof===false)return '';
	$p_data =json_decode( $dataprof, true );
	if(!is_array($p_data))return 'no array';
	$name = $p_data['data']['displayName'];
	$photo = $p_data['data']['thumbnailUrl'] .'?sz=44';
	$prof= '<div id="gps-profile"><a href="'.$plink.'" target="_blank"><span id="gps-profimg"><img src="'.$photo.'"/></span><span id="gps-dname">'.$name.'</span><br /><img src="https://lh5.googleusercontent.com/-VFhZfU6ZXbE/Tkbo_1kfPRI/AAAAAAAAATA/_6jQUcn8XKU/add2circle.png"/></a></div>';
	
	$tm=time();
	update_option('gps_ctime_prof',$tm);
	update_option('gps_cache_prof',$prof);
	return $prof;

}
function gps_get_stream()
{
 $id = get_option('gps_profid','');
 $url='https://plus.google.com/_/stream/getactivities/'.$id.'/?sp=[1,2,"'.$id.'",null,null,null,null,"social.google.com",[]]';
       $cache=gps_cache('stream');
	if($cache!==false)return '<div id="gps-cont"><ul>'.$cache.'</ul></div>';
      	
    $data = gps_get_data_url($url);
    if($data===false)return '';
    $p = str_replace(")]}'", "", $data);
    $p = str_replace('[,' , '["",' , $p); 
    $p = str_replace(',,' , ',"",' , $p); 
    $p = str_replace(',,' , ',"",' , $p); 
    $p_data = json_decode($p);
    if(!is_array($p_data[1][0]))return '';
    $cnt=1;
foreach ($p_data[1][0] as $post)
{
    	if($cnt>10)break;
    	$id = $post[21];
    	$ptime=$post[5]/1000;
    	$tz=date_default_timezone_get();
    	date_default_timezone_set(get_option('timezone_string'));
    	$ptime=date("M j, Y, g:i a",$ptime);
    	date_default_timezone_set($tz);
	$plink = "https://plus.google.com/".$post[21];
	$desc='';
    	if(trim($post[47])!="")$desc = $post[47];
    	else $desc = $post[4];  
    	
   	if(is_array($post[44]))
   		$desc= $desc.'<br/><br/><a href="https://plus.google.com/'.$post[44][1].'">'.$post[44][0].'</a> originally shared this post';
	if(is_array($post[66][0]))
		$desc= $desc.'<br/><br/><a href="'.$post[66][0][1].'">'.$post[66][0][3].'</a>';
	if(is_array($post[66][0][6][0]))
	{
		if(strpos($post[66][0][6][0][1],"image")!==false)
			$desc = $desc.' <p><img src="http:'.$post[66][0][6][0][2].'"/></p>';	
		else
			try {
        			$desc = $desc.' <a href="'.$post[66][0][6][0][8].'">'.$post[66][0][6][0][8].'</a>';
			} catch (Exception $e) {}
	}	
	if($desc == '')$desc = $plink;
	$boy.='<li><p><a href="'.$plink.'" target="_blank">'.$ptime.'</a></p>'.$desc.'</li>';
	$cnt=$cnt+1;
}
	$tm=time();
	update_option('gps_ctime',$tm);
	update_option('gps_cache',$boy);
	
	$boy='<div id="gps-cont"><ul>'.$boy.'</ul></div>';
	
	return $boy;

}


function gps_option()
{
if(isset($_GET['settings-updated']))
{
	update_option('gps_ctime',0);
	update_option('gps_ctime_prof',0);
}
?>
<form method="post" action="options.php">
<?php wp_nonce_field('update-options'); ?>
<h1>Google Plus Stream Options</h1>
<p>Like this Plugin then why not hit the like button. Your like will motivate me to enhance the features of the Plugin :)<br />
<iframe src="http://www.facebook.com/plugins/like.php?href=http%3A%2F%2Fwww.facebook.com%2Fpages%2FLet-us-Buzz%2F149408071759545&layout=standard&show_faces=false&width=450&action=like&font=verdana&colorscheme=light&height=35" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:450px; height:35px;" allowTransparency="true"></iframe><br />And if you are too generous then you can always <b>DONATE</b> by clicking the donation button.<br/>A Donation will help in the uninterrupted developement of the plugin.<br /><a href="http://letusbuzz.com/google-plus-stream-widget/" TARGET='_blank'>Click here</a> for <b>Reference on using the plugin</b> or if you want to <b>report a bug</b> or if you want to <b>suggest a Feature</b><br /></p>
<table class="form-ta">	
<tr valign="top">
<td>
<p>Google Plus ID<input type="text" name="gps_profid" style="width: 300px;" value="<?php echo get_option('gps_profid',''); ?>" /></p>
<p>Widget Title<input type="text" name="gps_title" style="width: 300px;" value="<?php echo get_option('gps_title','Google Plus Stream'); ?>" /></p>
<p>Height of Widget<input type="text" name="gps_height" value="<?php echo get_option('gps_height','400px'); ?>" /> Default 400px (Do not inculde ; in the end)</p>
<p>Cache Time in minutes<input type="text" name="gps_m2c" value="<?php echo get_option('gps_m2c',15); ?>" /></p>
<p></p>
<p><input type="checkbox" name="gps_credit" value="true"<?php if (get_option( 'gps_credit', true ) == true) echo ' checked'; ?>> Display Google Plus widget Link</p>

<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="gps_title,gps_m2c,gps_credit,gps_profid,gps_height" />
<p class="submit">
<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
</p>
</form>
</td>
<td width="20%"><b>Follow us on</b><br/><a href="http://twitter.com/letusbuzz" target="_blank"><img src="http://a0.twimg.com/a/1303316982/images/twitter_logo_header.png" /></a><br/><a href="http://facebook.com/letusbuzzz" target="_blank"><img src="https://secure-media-sf2p.facebook.com/ads3/creative/pressroom/jpg/b_1234209334_facebook_logo.jpg" height="38px" width="118px"/></a><p></p><b>Feeds and News</b><br /><?php get_feeds_gps('http://letusbuzz.com/feed','style="list-style-type:circle"') ?>
<p></p>
<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
<input type="hidden" name="cmd" value="_donations">
<input type="hidden" name="business" value="isudipto@gmail.com">
<input type="hidden" name="lc" value="US">
<input type="hidden" name="item_name" value="Google Plus Stream">
<input type="hidden" name="no_note" value="0">
<input type="hidden" name="currency_code" value="USD">
<input type="hidden" name="bn" value="PP-DonationsBF:btn_donateCC_LG.gif:NonHostedGuest">
<input type="image" src="https://www.paypalobjects.com/WEBSCR-640-20110401-1/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
<img alt="" border="0" src="https://www.paypalobjects.com/WEBSCR-640-20110401-1/en_US/i/scr/pixel.gif" width="1" height="1">
</form>
<br />Consider a Donation and remember $X is always better than $0
</td>
</tr>
</table>

<?php
}
function get_feeds_gps($link,$style) {
include_once(ABSPATH . WPINC . '/feed.php');
$rss = fetch_feed($link);
if (!is_wp_error( $rss )){
$rss5 = $rss->get_item_quantity(5); 
$rss1 = $rss->get_items(0, $rss5); 
}
?>
<ul>
<?php if (!$rss5 == 0)foreach ( $rss1 as $item ){?>
<li <?php echo $style; ?>>
<?php $plink=$item->get_permalink(); ?>
<?php if($plink!="" && isset($plink)){ ?>
<a target="_blank" href='<?php echo $item->get_permalink(); ?>'><?php echo $item->get_title(); ?></a>
<?php }else echo $item->get_title(); ?>
</li>
<?php } ?>
</ul>
<?php
}
function gps_admin()
{
	add_options_page('Google Plus Stream', 'Google Plus Stream', 7, 'googleplusstream', 'gps_option');
}
add_action('admin_menu', 'gps_admin');
?>
